## pcre2 10.39-3ubuntu0.1%2B11.0trisquel0

=== debian/control ===
Source: pcre2
Section: libs
Priority: optional
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer:  Matthew Vernon <matthew@debian.org>
Standards-Version: 4.5.1
Build-Depends: debhelper (>=9), dpkg-dev (>= 1.16.1~)
Vcs-Git: https://salsa.debian.org/debian/pcre2.git
Vcs-Browser: https://salsa.debian.org/debian/pcre2
Homepage: https://pcre.org/

Package: libpcre2-8-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: New Perl Compatible Regular Expression Library- 8 bit runtime files
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the 8 bit runtime library, which operates on
 ASCII and UTF-8 input.

Package: libpcre2-8-0-udeb
Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: New Perl Compatible Regular Expression Library- 8 bit runtime files (udeb)
 This package contains the 8 bit runtime library, for the Debian Installer.

Package: libpcre2-16-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: New Perl Compatible Regular Expression Library - 16 bit runtime files
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the 16 bit runtime library, which operates on
 UTF-16 input.

Package: libpcre2-32-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: New Perl Compatible Regular Expression Library - 32 bit runtime files
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the 32 bit runtime library, which operates on
 UTF-32 input.

Package: libpcre2-posix3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Replaces: libpcre2-posix0
Conflicts: libpcre2-posix0
Description: New Perl Compatible Regular Expression Library - posix-compatible runtime files
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the runtime library for the posix-compatible API.

Package: libpcre2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libpcre3-dev (<<2:8.35-8)
Depends: libc-dev, libpcre2-8-0 (= ${binary:Version}), libpcre2-16-0 (= ${binary:Version}), libpcre2-32-0 (= ${binary:Version}), libpcre2-posix3 (= ${binary:Version}), ${misc:Depends}
Description: New Perl Compatible Regular Expression Library - development files
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the development files, including headers,
 static libraries, and documentation.

Package: pcre2-utils
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: New Perl Compatible Regular Expression Library - utilities
 This is PCRE2, the new implementation of PCRE, a library of functions
 to support regular expressions whose syntax and semantics are as
 close as possible to those of the Perl 5 language. New projects
 should use this library in preference to the older library,
 confusingly called pcre3 in Debian.
 .
 This package contains the utilities pcre2grep (like grep with PCRE)
 and pcre2test (a test program for the library, but also useful for
 experimenting with regular expressions). Both programs are also
 useful examples of programming with libpcre2.

## pcre2 10.39-3ubuntu0.1+11.0trisquel0

=== debian/changelog ===
pcre2 (10.39-3ubuntu0.1+11.0trisquel0) aramo-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 01 Nov 2022 15:18:54 +0000

pcre2 (10.39-3ubuntu0.1) jammy-security; urgency=medium

  * SECURITY UPDATE: out-of-bounds read in pcre2_jit_compile
    - Fix a unicode property matching issue and an incorrect
      value reading in JIT in src/pcre2_jit_compile.c and
      src/pcre2_jit_test.c.
    - Fix a recursions issue in JIT caused by duplicated
      data transfers in src/pcre2_jit_compile.c and
      src/pcre2_jit_test.c.
    - CVE-2022-1586
    - CVE-2022-1587 

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Tue, 20 Sep 2022 12:46:17 +0200

pcre2 (10.39-3build1) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 17:22:31 +0100

pcre2 (10.39-3) unstable; urgency=medium

  * Enable JIT on s390x (Closes: #999836)
  * Re-enable JIT on MIPS (Closes: #892488)

 -- Matthew Vernon <matthew@debian.org>  Wed, 17 Nov 2021 14:52:42 +0000

pcre2 (10.39-2) unstable; urgency=medium

  * Update long descriptions of runtime packages (Closes: #978013)
  * Source-only upload (-1 was binary to get through NEW)
  * Depend on libc-dev rather than libc6-dev (Closes: #989729)

 -- Matthew Vernon <matthew@debian.org>  Mon, 08 Nov 2021 23:47:21 +0000

pcre2 (10.39-1) unstable; urgency=medium

  * New upstream release
  * Update watch file to reflect new upstream home on github
  * libpcre2-posix soname updated

 -- Matthew Vernon <matthew@debian.org>  Sat, 06 Nov 2021 13:56:27 +0000

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see dpkg-buildflags(1)
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
# prefix names of functions in libpcreposix with PCRE2 to avoid clash with
# ones in libc.
export DEB_CFLAGS_MAINT_APPEND = -Dregcomp=PCRE2regcomp -Dregexec=PCRE2regexec -Dregerror=PCRE2regerror -Dregfree=PCRE2regfree


deb_maint_conf_args = --enable-pcre2-16 --enable-pcre2-32 --disable-pcre2grep-callout
#enable JIT only on architectures that support it (see pcre2jit.3)
ifneq ($(filter i386 amd64 armel armhf mips mipsel mips64el powerpc sparc arm64 ppc64 ppc64el s390x, $(DEB_HOST_ARCH)),)
deb_maint_conf_args +=--enable-jit
else
deb_maint_conf_args +=--disable-jit
endif

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(deb_maint_conf_args)

override_dh_makeshlibs:
	dh_makeshlibs -V --add-udeb=libpcre2-8-0-udeb

override_dh_strip:
	dh_strip --dbgsym-migration='libpcre2-dbg (<< 10.34-2~)'

## pcre2 10.40

=== CMakeLists.txt ===
# CMakeLists.txt
#
# This file enables PCRE2 to be built with the CMake configuration and build
# tool. Download CMake in source or binary form from http://www.cmake.org/
# Converted to support PCRE2 from the original PCRE file, August 2014.
#
# Original listfile by Christian Ehrlicher <Ch.Ehrlicher@gmx.de>
# Refined and expanded by Daniel Richard G. <skunk@iSKUNK.ORG>
# 2007-09-14 mod by Sheri so 7.4 supported configuration options can be entered
# 2007-09-19 Adjusted by PH to retain previous default settings
# 2007-12-26 (a) On UNIX, use names libpcre instead of just pcre
#            (b) Ensure pcretest and pcregrep link with the local library,
#                not a previously-installed one.
#            (c) Add PCRE_SUPPORT_LIBREADLINE, PCRE_SUPPORT_LIBZ, and
#                PCRE_SUPPORT_LIBBZ2.
# 2008-01-20 Brought up to date to include several new features by Christian
#            Ehrlicher.
# 2008-01-22 Sheri added options for backward compatibility of library names
#            when building with minGW:
#            if "ON", NON_STANDARD_LIB_PREFIX causes shared libraries to
#            be built without "lib" as prefix. (The libraries will be named
#            pcre.dll, pcreposix.dll and pcrecpp.dll).
#            if "ON", NON_STANDARD_LIB_SUFFIX causes shared libraries to
#            be built with suffix of "-0.dll". (The libraries will be named
#            libpcre-0.dll, libpcreposix-0.dll and libpcrecpp-0.dll - same names
#            built by default with Configure and Make.
# 2008-01-23 PH removed the automatic build of pcredemo.
# 2008-04-22 PH modified READLINE support so it finds NCURSES when needed.
# 2008-07-03 PH updated for revised UCP property support (change of files)
# 2009-03-23 PH applied Steven Van Ingelgem's patch to change the name
#            CMAKE_BINARY_DIR to PROJECT_BINARY_DIR so that it works when PCRE
#            is included within another project.
# 2009-03-23 PH applied a modified version of Steven Van Ingelgem's patches to
#            add options to stop the building of pcregrep and the tests, and
#            to disable the final configuration report.
# 2009-04-11 PH applied Christian Ehrlicher's patch to show compiler flags that
#            are set by specifying a release type.
# 2010-01-02 PH added test for stdint.h
# 2010-03-02 PH added test for inttypes.h
# 2011-08-01 PH added PCREGREP_BUFSIZE
# 2011-08-22 PH added PCRE_SUPPORT_JIT
# 2011-09-06 PH modified WIN32 ADD_TEST line as suggested by Sergey Cherepanov
# 2011-09-06 PH added PCRE_SUPPORT_PCREGREP_JIT
# 2011-10-04 Sheri added support for including coff data in windows shared libraries
#            compiled with MINGW if pcre.rc and/or pcreposix.rc are placed in
#            the source dir by the user prior to building
# 2011-10-04 Sheri changed various add_test's to use exes' location built instead
#            of DEBUG location only (likely only matters in MSVC)
# 2011-10-04 Sheri added scripts to provide needed variables to RunTest and
#            RunGrepTest (used for UNIX and Msys)
# 2011-10-04 Sheri added scripts to provide needed variables and to execute
#            RunTest.bat in Win32 (for effortless testing with "make test")
# 2011-10-04 Sheri Increased minimum required cmake version
# 2012-01-06 PH removed pcre_info.c and added pcre_string_utils.c
# 2012-01-10 Zoltan Herczeg added libpcre16 support
# 2012-01-13 Stephen Kelly added out of source build support
# 2012-01-17 PH applied Stephen Kelly's patch to parse the version data out
#            of the configure.ac file
# 2012-02-26 PH added support for libedit
# 2012-09-06 PH added support for PCRE_EBCDIC_NL25
# 2012-09-08 ChPe added PCRE32 support
# 2012-10-23 PH added support for VALGRIND and GCOV
# 2012-12-08 PH added patch from Daniel Richard G to quash some MSVC warnings
# 2013-07-01 PH realized that the "support" for GCOV was a total nonsense and
#            so it has been removed.
# 2013-10-08 PH got rid of the "source" command, which is a bash-ism (use ".")
# 2013-11-05 PH added support for PARENS_NEST_LIMIT
# 2014-08-29 PH converted the file for PCRE2 (which has no C++).
# 2015-04-24 PH added support for PCRE2_DEBUG
# 2015-07-16 PH updated for new pcre2_find_bracket source module
# 2015-08-24 PH correct C_FLAGS setting (patch from Roy Ivy III)
# 2015-10=16 PH added support for never-backslash-C
# 2016-03-01 PH applied Chris Wilson's patch for MSVC static
# 2016-06-24 PH applied Chris Wilson's second patch, putting the first under
#            a new option instead of being unconditional.
# 2016-10-05 PH fixed a typo (PCRE should be PCRE2) in above patch
#            fix by David Gaussmann
# 2016-10-07 PH added PCREGREP_MAX_BUFSIZE
# 2017-03-11 PH turned HEAP_MATCH_RECURSE into a NO-OP for 10.30
# 2017-04-08 PH added HEAP_LIMIT
# 2017-06-15 ZH added SUPPORT_JIT_SEALLOC support
# 2018-06-19 PH added checks for stdint.h and inttypes.h (later removed)
# 2018-06-27 PH added Daniel's patch to increase the stack for MSVC
# 2018-11-14 PH removed unnecessary checks for stdint.h and inttypes.h
# 2018-11-16 PH added PCRE2GREP_SUPPORT_CALLOUT_FORK support and tidied
# 2019-02-16 PH hacked to avoid CMP0026 policy issue (see comments below)
# 2020-03-16 PH renamed dftables as pcre2_dftables (as elsewhere)
# 2020-03-24 PH changed CMAKE_MODULE_PATH definition to add, not replace
# 2020-04-08 Carlo added function check for secure_getenv, fixed strerror
# 2020-04-16 enh added check for __attribute__((uninitialized))
# 2020-04-25 PH applied patches from Uwe Korn to support pkg-config and
#            library versioning.
# 2020-04-25 Carlo added function check for mkostemp used in ProtExecAllocator
# 2020-04-28 PH added function check for memfd_create based on Carlo's patch
# 2020-05-25 PH added a check for Intel CET
# 2020-12-03 PH altered the definition of pcre2test as suggested by Daniel
# 2021-06-29 JWSB added the option to build static library with PIC.
# 2021-07-05 JWSB modified such both the static and shared library can be
#            build in one go.
# 2021-08-28 PH increased minimum version
# 2021-08-28 PH added test for realpath()

PROJECT(PCRE2 C)

# Increased minimum to 2.8.5 to support GNUInstallDirs.
# Increased minimum to 3.0.0 because older than 2.8.12 is deprecated.
CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0)

# Set policy CMP0026 to avoid warnings for the use of LOCATION in
# GET_TARGET_PROPERTY. This should no longer be required.
# CMAKE_POLICY(SET CMP0026 OLD)

# With a recent cmake, you can provide a rootdir to look for non
# standard installed library dependencies, but to do so, the policy
# needs to be set to new (by uncommenting the following)
# CMAKE_POLICY(SET CMP0074 NEW)

# For FindReadline.cmake. This was changed to allow setting CMAKE_MODULE_PATH
# on the command line.
# SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

LIST(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src)

# external packages
FIND_PACKAGE( BZip2 )
FIND_PACKAGE( ZLIB )
FIND_PACKAGE( Readline )
FIND_PACKAGE( Editline )

# Configuration checks

INCLUDE(CheckCSourceCompiles)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckTypeSize)
INCLUDE(GNUInstallDirs) # for CMAKE_INSTALL_LIBDIR

CHECK_INCLUDE_FILE(dirent.h     HAVE_DIRENT_H)
CHECK_INCLUDE_FILE(sys/stat.h   HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE(sys/types.h  HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE(unistd.h     HAVE_UNISTD_H)
CHECK_INCLUDE_FILE(windows.h    HAVE_WINDOWS_H)

CHECK_SYMBOL_EXISTS(bcopy         "strings.h"  HAVE_BCOPY)
CHECK_SYMBOL_EXISTS(memfd_create  "sys/mman.h" HAVE_MEMFD_CREATE)
CHECK_SYMBOL_EXISTS(memmove       "string.h"   HAVE_MEMMOVE)
CHECK_SYMBOL_EXISTS(secure_getenv "stdlib.h"   HAVE_SECURE_GETENV)
CHECK_SYMBOL_EXISTS(strerror      "string.h"   HAVE_STRERROR)

CHECK_C_SOURCE_COMPILES(
  "#include <stdlib.h>
   #include <limits.h>
   int main(int c, char *v[]) { char buf[PATH_MAX]; realpath(v[1], buf); return 0; }"
  HAVE_REALPATH
)

set(ORIG_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -Werror")
CHECK_C_SOURCE_COMPILES(
  "int main() { char buf[128] __attribute__((uninitialized)); (void)buf; return 0; }"
  HAVE_ATTRIBUTE_UNINITIALIZED
)
set(CMAKE_REQUIRED_FLAGS ${ORIG_CMAKE_REQUIRED_FLAGS})

# Check whether Intel CET is enabled, and if so, adjust compiler flags. This
# code was written by PH, trying to imitate the logic from the autotools
# configuration.

CHECK_C_SOURCE_COMPILES(
  "#ifndef __CET__
   #error CET is not enabled
   #endif
   int main() { return 0; }"
  INTEL_CET_ENABLED
)

IF (INTEL_CET_ENABLED)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mshstk")
ENDIF(INTEL_CET_ENABLED)



# User-configurable options
#
# Note: CMakeSetup displays these in alphabetical order, regardless of
# the order we use here.

SET(BUILD_SHARED_LIBS OFF CACHE BOOL "Build shared libraries.")

OPTION(BUILD_STATIC_LIBS "Build static libraries." ON)

OPTION(PCRE2_BUILD_PCRE2_8 "Build 8 bit PCRE2 library" ON)

OPTION(PCRE2_BUILD_PCRE2_16 "Build 16 bit PCRE2 library" OFF)

OPTION(PCRE2_BUILD_PCRE2_32 "Build 32 bit PCRE2 library" OFF)

OPTION(PCRE2_STATIC_PIC "Build the static library with the option position independent code enabled." OFF)

OPTION(PCRE2_DEBUG "Include debugging code" OFF)

OPTION(PCRE2_DISABLE_PERCENT_ZT "Disable the use of %zu and %td (rarely needed)" OFF)

SET(PCRE2_EBCDIC OFF CACHE BOOL
    "Use EBCDIC coding instead of ASCII. (This is rarely used outside of mainframe systems.)")

SET(PCRE2_EBCDIC_NL25 OFF CACHE BOOL
    "Use 0x25 as EBCDIC NL character instead of 0x15; implies EBCDIC.")

SET(PCRE2_LINK_SIZE "2" CACHE STRING
    "Internal link size (2, 3 or 4 allowed). See LINK_SIZE in config.h.in for details.")

SET(PCRE2_PARENS_NEST_LIMIT "250" CACHE STRING
    "Default nested parentheses limit. See PARENS_NEST_LIMIT in config.h.in for details.")

SET(PCRE2_HEAP_LIMIT "20000000" CACHE STRING
    "Default limit on heap memory (kibibytes). See HEAP_LIMIT in config.h.in for details.")

SET(PCRE2_MATCH_LIMIT "10000000" CACHE STRING
    "Default limit on internal looping. See MATCH_LIMIT in config.h.in for details.")

SET(PCRE2_MATCH_LIMIT_DEPTH "MATCH_LIMIT" CACHE STRING
    "Default limit on internal depth of search. See MATCH_LIMIT_DEPTH in config.h.in for details.")

SET(PCRE2GREP_BUFSIZE "20480" CACHE STRING
    "Buffer starting size parameter for pcre2grep. See PCRE2GREP_BUFSIZE in config.h.in for details.")

SET(PCRE2GREP_MAX_BUFSIZE "1048576" CACHE STRING
    "Buffer maximum size parameter for pcre2grep. See PCRE2GREP_MAX_BUFSIZE in config.h.in for details.")

SET(PCRE2_NEWLINE "LF" CACHE STRING
    "What to recognize as a newline (one of CR, LF, CRLF, ANY, ANYCRLF, NUL).")

SET(PCRE2_HEAP_MATCH_RECURSE OFF CACHE BOOL
    "Obsolete option: do not use")

SET(PCRE2_SUPPORT_JIT OFF CACHE BOOL
    "Enable support for Just-in-time compiling.")

IF(${CMAKE_SYSTEM_NAME} MATCHES Linux|NetBSD)
    SET(PCRE2_SUPPORT_JIT_SEALLOC OFF CACHE BOOL
        "Enable SELinux compatible execmem allocator in JIT (experimental).")
ELSE(${CMAKE_SYSTEM_NAME} MATCHES Linux|NetBSD)
    SET(PCRE2_SUPPORT_JIT_SEALLOC IGNORE)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES Linux|NetBSD)

SET(PCRE2GREP_SUPPORT_JIT ON CACHE BOOL
    "Enable use of Just-in-time compiling in pcre2grep.")

SET(PCRE2GREP_SUPPORT_CALLOUT ON CACHE BOOL
    "Enable callout string support in pcre2grep.")

SET(PCRE2GREP_SUPPORT_CALLOUT_FORK ON CACHE BOOL
    "Enable callout string fork support in pcre2grep.")

SET(PCRE2_SUPPORT_UNICODE ON CACHE BOOL
    "Enable support for Unicode and UTF-8/UTF-16/UTF-32 encoding.")

SET(PCRE2_SUPPORT_BSR_ANYCRLF OFF CACHE BOOL
    "ON=Backslash-R matches only LF CR and CRLF, OFF=Backslash-R matches all Unicode Linebreaks")

SET(PCRE2_NEVER_BACKSLASH_C OFF CACHE BOOL
    "If ON, backslash-C (upper case C) is locked out.")

SET(PCRE2_SUPPORT_VALGRIND OFF CACHE BOOL
    "Enable Valgrind support.")

## pcre2 10.42

=== CMakeLists.txt ===
--- 
+++ 
@@ -99,12 +99,12 @@
 #            build in one go.
 # 2021-08-28 PH increased minimum version
 # 2021-08-28 PH added test for realpath()
-
+# 2022-12-10 PH added support for pcre2posix_test
+
+# Increased minimum to 2.8.5 to support GNUInstallDirs.
+# Increased minimum to 3.1 to support imported targets.
+CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
 PROJECT(PCRE2 C)
-
-# Increased minimum to 2.8.5 to support GNUInstallDirs.
-# Increased minimum to 3.0.0 because older than 2.8.12 is deprecated.
-CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0)
 
 # Set policy CMP0026 to avoid warnings for the use of LOCATION in
 # GET_TARGET_PROPERTY. This should no longer be required.

## pcre2 10.42-4ubuntu2.1trisquel0

=== debian/changelog ===
pcre2 (10.42-4ubuntu2.1trisquel0) ecne; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 28 Jan 2025 16:45:19 +0000

pcre2 (10.42-4ubuntu2.1) noble; urgency=medium

  * SRU: LP: #2083480: No-change rebuild to disable frame pointers on
    ppc64el and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 02 Oct 2024 14:40:51 +0200

pcre2 (10.42-4ubuntu2) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:15:28 +0200

pcre2 (10.42-4ubuntu1) noble; urgency=medium

  * Disable JIT on riscv64 for now, regressing all
    kde packages
  * Enable testsuite on riscv64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 10 Dec 2023 20:39:53 +0100

pcre2 (10.42-4) unstable; urgency=medium

  * Build with JIT support on riscv64 (Closes: #1050819)

 -- Matthew Vernon <matthew@debian.org>  Tue, 29 Aug 2023 18:23:44 +0100

pcre2 (10.42-3) unstable; urgency=medium

  * Specify source format 1.0 explicitly (Closes: #1049910)

 -- Matthew Vernon <matthew@debian.org>  Mon, 21 Aug 2023 11:44:09 +0100

pcre2 (10.42-2) unstable; urgency=medium

  * disable JIT on sparc (Closes: #1034779)

 -- Matthew Vernon <matthew@debian.org>  Tue, 11 Jul 2023 23:11:09 +0100

pcre2 (10.42-1) unstable; urgency=medium

  * New upstream version

 -- Matthew Vernon <matthew@debian.org>  Sun, 01 Jan 2023 15:44:06 +0000

pcre2 (10.40-3) unstable; urgency=medium

  * Support the noudeb build profile (Helmut Grohne). (Closes: #1024941)

 -- Matthew Vernon <matthew@debian.org>  Fri, 02 Dec 2022 17:40:13 +0000

pcre2 (10.40-2) unstable; urgency=low

  * Move to machine-readable copyright file (Bastian Germann)
  * Remove filenamemangle from debian/watch (Bastian Germann)

 -- Matthew Vernon <matthew@debian.org>  Sun, 23 Oct 2022 16:07:18 +0100

pcre2 (10.40-1) unstable; urgency=medium

  * New upstream release
  * Update watch file to note new upstream repo location

 -- Matthew Vernon <matthew@debian.org>  Mon, 25 Apr 2022 17:10:36 +0100

pcre2 (10.39-4) unstable; urgency=medium

  * Backport upstream Hurd build fix (Closes: #1009066)

 -- Matthew Vernon <matthew@debian.org>  Mon, 11 Apr 2022 09:23:48 +0100

=== debian/control ===
--- 
+++ 
@@ -27,6 +27,7 @@
 
 Package: libpcre2-8-0-udeb
 Package-Type: udeb
+Build-Profiles: <!noudeb>
 Section: debian-installer
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -10,10 +10,16 @@
 # ones in libc.
 export DEB_CFLAGS_MAINT_APPEND = -Dregcomp=PCRE2regcomp -Dregexec=PCRE2regexec -Dregerror=PCRE2regerror -Dregfree=PCRE2regfree
 
+ifeq ($(DEB_HOST_ARCH),riscv64)
+ifeq ($(DEB_BUILD_ARCH),riscv64)
+# Force testsuite on riscv64
+DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))
+endif
+endif
 
 deb_maint_conf_args = --enable-pcre2-16 --enable-pcre2-32 --disable-pcre2grep-callout
 #enable JIT only on architectures that support it (see pcre2jit.3)
-ifneq ($(filter i386 amd64 armel armhf mips mipsel mips64el powerpc sparc arm64 ppc64 ppc64el s390x, $(DEB_HOST_ARCH)),)
+ifneq ($(filter amd64 armel armhf arm64 i386 mips mipsel mips64el powerpc ppc64 ppc64el s390x, $(DEB_HOST_ARCH)),)
 deb_maint_conf_args +=--enable-jit
 else
 deb_maint_conf_args +=--disable-jit

## pcre2 10.46

=== CMakeLists.txt ===
--- 
+++ 
@@ -100,11 +100,25 @@
 # 2021-08-28 PH increased minimum version
 # 2021-08-28 PH added test for realpath()
 # 2022-12-10 PH added support for pcre2posix_test
-
-# Increased minimum to 2.8.5 to support GNUInstallDirs.
-# Increased minimum to 3.1 to support imported targets.
-CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
-PROJECT(PCRE2 C)
+# 2023-01-15 Carlo added C99 as the minimum required
+# 2023-08-06 PH added support for setting variable length lookbehind maximum
+
+################################################################################
+# We have used `gersemi` for auto-formatting our CMake files.
+# Applied to all CMake files using:
+#    > pip3 install gersemi
+#    > gersemi --in-place --line-length 120 --indent 2 \
+#          ./CMakeLists.txt ./cmake/*.cmake ./cmake/*.cmake.in
+################################################################################
+
+# Increased minimum to 3.15 to allow use of string(REPEAT).
+cmake_minimum_required(VERSION 3.15 FATAL_ERROR)
+project(PCRE2 C)
+set(CMAKE_C_STANDARD 99)
+set(CMAKE_C_STANDARD_REQUIRED TRUE)
+
+set(CMAKE_C_VISIBILITY_PRESET hidden)
+cmake_policy(SET CMP0063 NEW)
 
 # Set policy CMP0026 to avoid warnings for the use of LOCATION in
 # GET_TARGET_PROPERTY. This should no longer be required.
@@ -119,152 +133,173 @@
 # on the command line.
 # SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
 
-LIST(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
-
-INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src)
+list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
+
+include_directories(${PROJECT_SOURCE_DIR}/src)
 
 # external packages
-FIND_PACKAGE( BZip2 )
-FIND_PACKAGE( ZLIB )
-FIND_PACKAGE( Readline )
-FIND_PACKAGE( Editline )
+find_package(BZip2)
+find_package(ZLIB)
+find_package(Readline)
+find_package(Editline)
 
 # Configuration checks
 
-INCLUDE(CheckCSourceCompiles)
-INCLUDE(CheckFunctionExists)
-INCLUDE(CheckSymbolExists)
-INCLUDE(CheckIncludeFile)
-INCLUDE(CheckTypeSize)
-INCLUDE(GNUInstallDirs) # for CMAKE_INSTALL_LIBDIR
-
-CHECK_INCLUDE_FILE(dirent.h     HAVE_DIRENT_H)
-CHECK_INCLUDE_FILE(sys/stat.h   HAVE_SYS_STAT_H)
-CHECK_INCLUDE_FILE(sys/types.h  HAVE_SYS_TYPES_H)
-CHECK_INCLUDE_FILE(unistd.h     HAVE_UNISTD_H)
-CHECK_INCLUDE_FILE(windows.h    HAVE_WINDOWS_H)
-
-CHECK_SYMBOL_EXISTS(bcopy         "strings.h"  HAVE_BCOPY)
-CHECK_SYMBOL_EXISTS(memfd_create  "sys/mman.h" HAVE_MEMFD_CREATE)
-CHECK_SYMBOL_EXISTS(memmove       "string.h"   HAVE_MEMMOVE)
-CHECK_SYMBOL_EXISTS(secure_getenv "stdlib.h"   HAVE_SECURE_GETENV)
-CHECK_SYMBOL_EXISTS(strerror      "string.h"   HAVE_STRERROR)
-
-CHECK_C_SOURCE_COMPILES(
-  "#include <stdlib.h>
-   #include <limits.h>
-   int main(int c, char *v[]) { char buf[PATH_MAX]; realpath(v[1], buf); return 0; }"
+include(CheckCSourceCompiles)
+include(CheckFunctionExists)
+include(CheckSymbolExists)
+include(CheckIncludeFile)
+include(CheckTypeSize)
+include(GNUInstallDirs) # for CMAKE_INSTALL_LIBDIR
+
+check_include_file(assert.h HAVE_ASSERT_H)
+check_include_file(dirent.h HAVE_DIRENT_H)
+check_include_file(sys/stat.h HAVE_SYS_STAT_H)
+check_include_file(sys/types.h HAVE_SYS_TYPES_H)
+check_include_file(unistd.h HAVE_UNISTD_H)
+check_include_file(windows.h HAVE_WINDOWS_H)
+
+check_symbol_exists(bcopy "strings.h" HAVE_BCOPY)
+check_symbol_exists(memfd_create "sys/mman.h" HAVE_MEMFD_CREATE)
+check_symbol_exists(memmove "string.h" HAVE_MEMMOVE)
+check_symbol_exists(secure_getenv "stdlib.h" HAVE_SECURE_GETENV)
+check_symbol_exists(strerror "string.h" HAVE_STRERROR)
+
+check_c_source_compiles(
+  [=[
+  #include <stdlib.h>
+  #include <limits.h>
+  int main(int c, char *v[]) { char buf[PATH_MAX]; realpath(v[c], buf); return 0; }
+  ]=]
   HAVE_REALPATH
 )
 
 set(ORIG_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
-set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -Werror")
-CHECK_C_SOURCE_COMPILES(
-  "int main() { char buf[128] __attribute__((uninitialized)); (void)buf; return 0; }"
+if(NOT MSVC AND NOT CMAKE_C_COMPILER_ID STREQUAL "XL")
+  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -Werror")
+endif()
+
+check_c_source_compiles(
+  "int main(void) { char buf[128] __attribute__((uninitialized)); (void)buf; return 0; }"
   HAVE_ATTRIBUTE_UNINITIALIZED
 )
+
+check_c_source_compiles(
+  [=[
+  extern __attribute__ ((visibility ("default"))) int f(void);
+  int main(void) { return f(); }
+  int f(void) { return 42; }
+  ]=]
+  HAVE_VISIBILITY
+)
+
 set(CMAKE_REQUIRED_FLAGS ${ORIG_CMAKE_REQUIRED_FLAGS})
+
+check_c_source_compiles("int main(void) { __assume(1); return 0; }" HAVE_BUILTIN_ASSUME)
+
+check_c_source_compiles(
+  [=[
+  #include <stddef.h>
+  int main(void) { int a,b; size_t m; __builtin_mul_overflow(a,b,&m); return 0; }
+  ]=]
+  HAVE_BUILTIN_MUL_OVERFLOW
+)
+
+check_c_source_compiles(
+  "int main(int c, char *v[]) { if (c) __builtin_unreachable(); return (int)(*v[0]); }"
+  HAVE_BUILTIN_UNREACHABLE
+)
+
+if(HAVE_VISIBILITY)
+  set(PCRE2_EXPORT [=[__attribute__ ((visibility ("default")))]=])
+else()
+  set(PCRE2_EXPORT)
+endif()
 
 # Check whether Intel CET is enabled, and if so, adjust compiler flags. This
 # code was written by PH, trying to imitate the logic from the autotools
 # configuration.
 
-CHECK_C_SOURCE_COMPILES(
-  "#ifndef __CET__
-   #error CET is not enabled
-   #endif
-   int main() { return 0; }"
+check_c_source_compiles(
+  [=[
+  #ifndef __CET__
+  #error CET is not enabled
+  #endif
+  int main() { return 0; }
+  ]=]
   INTEL_CET_ENABLED
 )
 
-IF (INTEL_CET_ENABLED)
-  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mshstk")
-ENDIF(INTEL_CET_ENABLED)
-
-
+if(INTEL_CET_ENABLED)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mshstk")
+endif()
 
 # User-configurable options
 #
 # Note: CMakeSetup displays these in alphabetical order, regardless of
 # the order we use here.
 
-SET(BUILD_SHARED_LIBS OFF CACHE BOOL "Build shared libraries.")
-
-OPTION(BUILD_STATIC_LIBS "Build static libraries." ON)
-
-OPTION(PCRE2_BUILD_PCRE2_8 "Build 8 bit PCRE2 library" ON)
-
-OPTION(PCRE2_BUILD_PCRE2_16 "Build 16 bit PCRE2 library" OFF)
-
-OPTION(PCRE2_BUILD_PCRE2_32 "Build 32 bit PCRE2 library" OFF)
-
-OPTION(PCRE2_STATIC_PIC "Build the static library with the option position independent code enabled." OFF)
-
-OPTION(PCRE2_DEBUG "Include debugging code" OFF)
-
-OPTION(PCRE2_DISABLE_PERCENT_ZT "Disable the use of %zu and %td (rarely needed)" OFF)
-
-SET(PCRE2_EBCDIC OFF CACHE BOOL
-    "Use EBCDIC coding instead of ASCII. (This is rarely used outside of mainframe systems.)")
-
-SET(PCRE2_EBCDIC_NL25 OFF CACHE BOOL
-    "Use 0x25 as EBCDIC NL character instead of 0x15; implies EBCDIC.")
-
-SET(PCRE2_LINK_SIZE "2" CACHE STRING
-    "Internal link size (2, 3 or 4 allowed). See LINK_SIZE in config.h.in for details.")
-
-SET(PCRE2_PARENS_NEST_LIMIT "250" CACHE STRING
-    "Default nested parentheses limit. See PARENS_NEST_LIMIT in config.h.in for details.")
-
-SET(PCRE2_HEAP_LIMIT "20000000" CACHE STRING
-    "Default limit on heap memory (kibibytes). See HEAP_LIMIT in config.h.in for details.")
-
-SET(PCRE2_MATCH_LIMIT "10000000" CACHE STRING
-    "Default limit on internal looping. See MATCH_LIMIT in config.h.in for details.")
-
-SET(PCRE2_MATCH_LIMIT_DEPTH "MATCH_LIMIT" CACHE STRING
-    "Default limit on internal depth of search. See MATCH_LIMIT_DEPTH in config.h.in for details.")
-
-SET(PCRE2GREP_BUFSIZE "20480" CACHE STRING
-    "Buffer starting size parameter for pcre2grep. See PCRE2GREP_BUFSIZE in config.h.in for details.")
-
-SET(PCRE2GREP_MAX_BUFSIZE "1048576" CACHE STRING
-    "Buffer maximum size parameter for pcre2grep. See PCRE2GREP_MAX_BUFSIZE in config.h.in for details.")
-
-SET(PCRE2_NEWLINE "LF" CACHE STRING
-    "What to recognize as a newline (one of CR, LF, CRLF, ANY, ANYCRLF, NUL).")
-
-SET(PCRE2_HEAP_MATCH_RECURSE OFF CACHE BOOL
-    "Obsolete option: do not use")
-
-SET(PCRE2_SUPPORT_JIT OFF CACHE BOOL
-    "Enable support for Just-in-time compiling.")
-
-IF(${CMAKE_SYSTEM_NAME} MATCHES Linux|NetBSD)
-    SET(PCRE2_SUPPORT_JIT_SEALLOC OFF CACHE BOOL
-        "Enable SELinux compatible execmem allocator in JIT (experimental).")
-ELSE(${CMAKE_SYSTEM_NAME} MATCHES Linux|NetBSD)
-    SET(PCRE2_SUPPORT_JIT_SEALLOC IGNORE)
-ENDIF(${CMAKE_SYSTEM_NAME} MATCHES Linux|NetBSD)
-
-SET(PCRE2GREP_SUPPORT_JIT ON CACHE BOOL
-    "Enable use of Just-in-time compiling in pcre2grep.")
-
-SET(PCRE2GREP_SUPPORT_CALLOUT ON CACHE BOOL
-    "Enable callout string support in pcre2grep.")
-
-SET(PCRE2GREP_SUPPORT_CALLOUT_FORK ON CACHE BOOL
-    "Enable callout string fork support in pcre2grep.")
-
-SET(PCRE2_SUPPORT_UNICODE ON CACHE BOOL
-    "Enable support for Unicode and UTF-8/UTF-16/UTF-32 encoding.")
-
-SET(PCRE2_SUPPORT_BSR_ANYCRLF OFF CACHE BOOL
-    "ON=Backslash-R matches only LF CR and CRLF, OFF=Backslash-R matches all Unicode Linebreaks")
-
-SET(PCRE2_NEVER_BACKSLASH_C OFF CACHE BOOL
-    "If ON, backslash-C (upper case C) is locked out.")
-
-SET(PCRE2_SUPPORT_VALGRIND OFF CACHE BOOL
-    "Enable Valgrind support.")
-
+set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build shared libraries.")
+
+option(BUILD_STATIC_LIBS "Build static libraries." ON)
+
+option(PCRE2_BUILD_PCRE2_8 "Build 8 bit PCRE2 library" ON)
+
+option(PCRE2_BUILD_PCRE2_16 "Build 16 bit PCRE2 library" OFF)
+
+option(PCRE2_BUILD_PCRE2_32 "Build 32 bit PCRE2 library" OFF)
+
+option(PCRE2_STATIC_PIC "Build the static library with the option position independent code enabled." OFF)
+
+set(PCRE2_DEBUG "IfDebugBuild" CACHE STRING "Include debugging code")
+set_property(CACHE PCRE2_DEBUG PROPERTY STRINGS "IfDebugBuild" "ON" "OFF")
+
+option(PCRE2_DISABLE_PERCENT_ZT "Disable the use of %zu and %td (rarely needed)" OFF)
+
+set(
+  PCRE2_EBCDIC
+  OFF
+  CACHE BOOL
+  "Use EBCDIC coding instead of ASCII. (This is rarely used outside of mainframe systems.)"
+)
+
+set(PCRE2_EBCDIC_NL25 OFF CACHE BOOL "Use 0x25 as EBCDIC NL character instead of 0x15; implies EBCDIC.")
+
+set(
+  PCRE2_LINK_SIZE
+  "2"
+  CACHE STRING
+  "Internal link size (2, 3 or 4 allowed). See LINK_SIZE in config.h.in for details."
+)
+
+set(
+  PCRE2_PARENS_NEST_LIMIT
+  "250"
+  CACHE STRING
+  "Default nested parentheses limit. See PARENS_NEST_LIMIT in config.h.in for details."
+)
+
+set(
+  PCRE2_HEAP_LIMIT
+  "20000000"
+  CACHE STRING
+  "Default limit on heap memory (kibibytes). See HEAP_LIMIT in config.h.in for details."
+)
+
+set(PCRE2_MAX_VARLOOKBEHIND "255" CACHE STRING "Default limit on variable lookbehinds.")
+
+set(
+  PCRE2_MATCH_LIMIT
+  "10000000"
+  CACHE STRING
+  "Default limit on internal looping. See MATCH_LIMIT in config.h.in for details."
+)
+
+set(
+  PCRE2_MATCH_LIMIT_DEPTH
+  "MATCH_LIMIT"
+  CACHE STRING
+  "Default limit on internal depth of search. See MATCH_LIMIT_DEPTH in config.h.in for details."
+)
+
+set(
